<template lang="pug">
	section#perfil
		barraLateral

		.principal
			Avatar()
			hgroup.nombre
				h1 {{ perfil.nombre }}
				h2 {{ perfil.apellidos }}
			hr
			.datos
				strong Correo:
				span {{ usuario.correo }}
				strong Teléfono:
				span {{ perfil.telefono }}
				//-strong Último acceso:
				//-span {{ ultimo_acceso }}
			button.editar(type='button', @click="edicion = !edicion"): img( src="@img/edit.svg")
		//-article.mensajes
			.mensaje.ok Copiado Exitoso
			.mensaje.error No se puede eliminar la carpeta
			.mensaje.info No tienes permisos suficientes

		form.contenido( v-if="edicion", @submit.prevent="formSubmit" )
			.foto
				figure( v-show="!nuevaFoto", ): img( :src="datos.imagen", alt="alt")
				vue-croppie.editor(
					v-show="nuevaFoto",
					ref="editor",
					:enableOrientation="true",
					@result="editorResult",
					@update="editorUpdate",
					:enableExif="true",
					:enableResize="false",
					:viewport= "editor.viewport",
					:boundary="editor.boundary",
				)
				.cambiar
					input#foto( type="file", ref="foto", @change="fotoChange" )
					span Cambiar Imagen

			.datos
				h3 Editar mis datos
				itemCampo( v-model="datos.nombre", titulo="Nombre", tipo="text", :obligatorio="true" )
				itemCampo( v-model="datos.apellidos", titulo="Apellido", tipo="text", :obligatorio="true" )
				itemCampo( v-model="datos.correo", titulo="Correo", tipo="email", :obligatorio="true" )
				itemCampo( v-model="datos.telefono", titulo="Télefono", tipo="tel", :obligatorio="true" )

			.clave
				h3 Cambiar clave
				itemCampo( v-model="clave", titulo="Clave", tipo="password", minlength="7")
				itemCampo( v-model="confirmacion", titulo="Confirmar Clave", tipo="password", :obligatorio="clave.length > 0" )

			.acciones
				button( type="submit" ) Guardar


		//-article.listas
			tarjeta.archivos( titulo="Archivos Públicos", estado="activo" )
				Listado

			tarjeta.comentarios( titulo="Comentarios Recientes", estado="activo" )
				.lista
					ItemComentario( v-for="comentario in comentarios", :key="comentario.id", :comentario="comentario" )
		//-p perfil


</template>


<script>
import BarraLateral from '@/components/BarraLateral'
import Avatar from '@/components/Avatar'
import Tarjeta from '@/components/Tarjeta'
import Listado from '@/components/Listado'
import ItemComentario from '@/components/ItemComentario'
import ItemCampo from '@/components/ItemCampo'

import { mapState, mapActions, mapMutations } from "vuex"

export default {
	name:"Perfil",
	components:{
		BarraLateral,
		Avatar,
		Tarjeta,
		Listado,
		ItemComentario,
		ItemCampo
	},
	data(){
		return{
			edicion:false,
			datos:{
				nombre:"",
				apellidos:"",
				correo:"",
				telefono:"",
				imagen:"http://1x1px.me/000000-0.png"
			},
			nuevaFoto:false,
			clave: "",
			confirmacion: "",
			editor:{
				viewport: {
					width: 180,
					height: 180,
					type: 'circle'
				},
				boundary: {
					width: 180,
					height: 180
				}
			}

		}
	},
	computed:{
		...mapState([
			"perfil",
			"usuario"
		])
	},
	watch:{
		edicion( n ){
			if ( n ) {
				this.datos = {
					nombre : this.perfil.nombre,
					apellidos : this.perfil.apellidos,
					correo : this.usuario.correo,
					telefono : this.perfil.telefono,
					imagen : this.perfil.imagen
				}
			}
		}
	},
	methods:{
		formSubmit( e ){
			//this.esperando = true;
			const { nombre, apellidos, correo, telefono, imagen }= this.datos;
			const datos = { nombre, apellidos, correo, telefono, imagen };

			if ( this.clave !== this.confirmacion ) {
				alert( "Las claves ingresadas no corresponden" );
				return;
			}
			else if( this.clave.length > 0 ){
				datos.clave = this.clave;
			}
			//console.log( datos );
			this.guardarPerfil( datos );
			this.edicion = false;
			this.nuevaFoto = false;
		},
		fotoChange(){
			//console.log( "fotoChange", arguments, this.$refs.foto );
			//console.log( this.$refs.foto.files[0] );
			const reader = new FileReader();
			const editor = this.$refs.editor;
			reader.onload = function(){
				editor.bind({
					url: reader.result,
				});
			};
			this.nuevaFoto = true;
			reader.readAsDataURL( this.$refs.foto.files[0] );
		},
		editorResult(output){
			this.datos.imagen = output;
		},
		editorUpdate( val ){
			//console.log(val);
			let options = {
				format: 'webp',
				circle: false
			}
			this.$refs.editor.result(options);
		},
		...mapActions([
			"obtenerPerfil",
			"guardarPerfil"
		])
	},
	beforeMount(){
		this.obtenerPerfil();

	},
	mounted(){
		this.datos = {
			nombre : this.perfil.nombre,
			apellidos : this.perfil.apellidos,
			correo : this.usuario.correo,
			telefono : this.perfil.telefono,
			imagen : this.perfil.imagen
		}

	}
}
</script>

<style lang="stylus" scoped>
@import '~nib/index'
@import "../stylus/base/utiles.styl"

#perfil
	display grid
	grid-template-areas "lateral mensajes" \
		"lateral principal" \
		"lateral contenido" \
		"lateral listas"
	grid-template-columns 25vw 1fr
	grid-template-rows repeat( 3, min-content) 1fr
	grid-gap 0 1rem
	padding 1rem
	background-color blanco

	.barraLateral
		grid-area lateral
		margin-left -1rem
		margin-bottom -1rem

	.principal
		grid-area principal
		background-color gris_claro
		padding 1rem
		display flex
		align-items center
		flex-wrap wrap
		margin-bottom 0.15rem
		position relative

		.avatar
			width 135px
			margin 1rem
			box-shadow 0 4px 32px -4px alpha( negro, 50% )

		hgroup
			padding 1rem
			font-size calcRem( 30 )
			color blanco

			h1
				font-weight 500
			h2
				font-weight 300

		hr
			width 0
			height auto
			align-self stretch
			border-left 1px solid tint( azul, 90% )
			border-right 1px solid tint( azul, 80% )
			margin 1rem

		.datos
			padding 1rem
			display grid
			grid-template-columns auto 1fr
			grid-gap 0.5em 1rem

			strong
				color blanco
				font-weight 400

			span
				color  blanco

		.editar
			background-color transparente
			absolute top right
			color tint( azul, 50% )
			padding 0.5rem
			border-radius 2rem

			&:hover
				background-color tint( azul, 90% )

			img
				opacity 0.7
				height 1.5rem
				width 1.5rem



	.contenido
		grid-area contenido
		padding 2rem
		background-color gris_claro
		margin-bottom 1rem
		display grid
		grid-template-areas "foto datos clave" \
			"opciones opciones opciones" \
			"acciones acciones acciones"
		grid-gap 1rem 2rem
		grid-template-columns 2fr 5fr 4fr

		.foto
			grid-area foto
			display flex
			flex-direction column
			position relative

			figure
				background-color azul
				width 100%

			.editor
				display block
				//-absolute top left right bottom
				width auto

				>>> .cr-slider-wrap
					.cr-slider
						width auto

			.cambiar
				background-color azul
				display block
				width auto
				padding 0.5em
				font-size calcRem( 14 )
				color blanco
				position relative
				cursor pointer

				&:hover
					background-color tint( azul, 20% )

				input
					absolute top left right bottom
					width 100%
					height 100%
					opacity 0
					cursor pointer

				span
					display block
					text-align center

		.datos
			grid-area datos

		.clave
			grid-area clave

		.itemCampo
			margin-bottom 0.75rem

		h3
			padding-bottom .5em
			margin-bottom 0.5em
			//border-bottom 2px solid tint( azul, 40% )
			color tint( azul, 40% )
			font-size calcRem( 16 )
			font-weight 500

		.acciones
			grid-area acciones
			display flex
			justify-content flex-end

			button
				background-color azul
				display block
				width auto
				padding 0.75em 1.5rem
				font-size calcRem( 14 )
				color blanco
				border-radius 3em

	.listas
		grid-area listas

		.tarjeta
			margin-bottom 1rem

		.archivos
			>>> header
				background-color tint( rojo, 40% )
				color blanco

		.comentarios
			.lista
				display grid
				grid-template-columns repeat( 3, 1fr )
				grid-gap 0.5rem

.mensajes
	grid-area mensajes

	.mensaje
		font-size calcRem( 12 )
		padding .5em 1rem
		margin-bottom 0.2em
		border 1px solid gris
		box-sizing border-box
		color alpha( darken(gris, 50% ), 75% )
		background-color tint(gris, 50%)
		font-weight 300
		cursor pointer

		&::before
			content "mensaje:"
			text-transform uppercase
			font-weight bolder
			margin-right .2em

		&.ok
			background-color tint(green, 50%)
			border-color desaturate( green, 50% )

			&::before
				content: "correcto:"

		&.error
			background-color tint(red, 50%)
			border-color desaturate( red, 50% )

			&::before
				content: "error:"

		&.info
			background-color tint( cyan, 50%)
			border-color desaturate( cyan, 50% )

			&::before
				content: "atención:"

</style>
